/*---------------------------------
Fred Paulino Ferreira - 47662
Exercicio de INF251
Somador de n bits (n fornecido pelo usurio)
12/10/2004
---------------------------------*/

#include<fstream.h>
#include<iostream.h>

int main(){

fstream arq("sumNbits.hds", ios::out);

if(!arq){
	cout << "Error: Cannot Open File - sumNbits.hds" << endl;
	exit(-1);
}

int n=0, posx=9000, posy=9000;

cout << "N bit adder - Enter the number of bits:" << endl;
cin >> n;
if(n <= 0){
	cout << "N must be greater than 0 !" << endl;
	exit(-1);
}

arq << "# hades.models.Design file"
	 << "\n#"
	 << "\n[name] somadorNbits"
	 << "\n[components]"
	 << "\nhades.models.rtlib.io.OpinVector C 9900 17100 @N 1001 " << n << " 1.0E-9 0"
	 << "\nhades.models.rtlib.io.IpinVector B 8700 2100 @N 1001 " << n << " UUU_B 1.0E-9 0"
	 << "\nhades.models.rtlib.io.IpinVector A 8700 0 @N 1001 " << n << " UUU_B 1.0E-9 0"
	 << "\nhades.models.rtlib.io.Expander expansor_1 8700 3300 @N 1001 " << n << " 1.0E-8"
	 << "\nhades.models.rtlib.io.Expander expansor_2 16000 3300 @N 1001 " << n << " 1.0E-8"
	 << "\nhades.models.rtlib.io.MergeBits merge 9000 14100 @N 1001 " << n << " 1.0E-8"
	 << "\nhades.models.io.Opin Ov/Und 20000 16000 @N 1001 5.0E-9"
	 << "\nhades.models.io.Ipin AddorSub 5000 10000 @N 1001 0";

for(int i = 0 ; i < n ; i++){ //Cria os somadores
	arq << "\nhades.models.gates.Xor2 XOR_" << i << " " << posx + 10500 << " 5500 @N 1001 1.0E-8"
	    << "\nhades.models.Design somador_" << i << " " << posx << " " << posy
	    << " @N 1001 somador1bit_3Entradas.hds";
	posx += 5000;
}
arq << "\nhades.models.gates.Xor2 XOR " << posx<< " " << posy << " @N 1001 1.0E-8";

arq << "\n[end components]"
	 << "\n[signals]"
	 << "\nhades.signals.SignalStdLogicVector barramento_1 " << n << " 2 B Y expansor_2 A 0 0"
	 << "\nhades.signals.SignalStdLogicVector barramento_2 " << n << " 2 A Y expansor_1 A 0 0"
	 << "\nhades.signals.SignalStdLogic1164 fio_overflow 2 Ov/Und A XOR Y 0 0";

int j=0;
for(int i = 0 ; i < n ; i++){ //Liga o expansor 1 nos bits Ai dos somadores
	arq << "\nhades.signals.SignalStdLogic1164 fio_" << j
		 << " 2 expansor_1 Y" << i << " somador_" << i << " Ai 0 0";
	j++;
}
 
for(int i = 0; i < n ; i++){ //Liga o expansor 2  na entrada A de todas as portas XOR
	j++;
	arq << "\nhades.signals.SignalStdLogic1164 fio_" << j << " 2 expansor_2 Y"
		 << i << " XOR_" << i << " A 0 0";
}

j++;
arq << "\nhades.signals.SignalStdLogic1164 fio_" << j
	 << " " << n + 3 << " AddorSub Y somador_0 vem_um XOR A ";
for(int i = 0; i < n ; i++){ //Liga o AddorSub na entrada B de todas as portas XOR
	arq << " XOR_" << i << " B";
}
arq << " " << n + 2 << " 2 0";

for(int i = 0; i < n ; i++){ //Liga as saidas das portas XOR nos bits Bi dos somadores
	j++;
	arq << "\nhades.signals.SignalStdLogic1164 fio_" << j
		 << " 2 XOR_" << i << " Y somador_" << i << " Bi 0 0";
}

for(int i = 0; i < n-1 ; i++){ //Liga o vai_um de um somador no vem_um do prximo somador
	j++;
	arq << "\nhades.signals.SignalStdLogic1164 fio_" << j
		 << " 2 somador_" << i << " vai_um somador_" << i + 1 << " vem_um 0 0";
}

for(int i = 0; i < n ; i++){ //Liga a saida soma de cada somador no mergebit
	j++;
	arq << "\nhades.signals.SignalStdLogic1164 fio_" << j
		 << " 2 somador_" << i << " soma merge A" << i << " 0 0";
}

//Liga a saida da porta XOR no Opin Ov/Und
arq << "\nhades.signals.SignalStdLogic1164 fio_" << ++j << " 2 XOR B somador_" << n - 1 << " vai_um 0 0";

arq << "\nhades.signals.SignalStdLogicVector barramento_3 " << n << " 2 C A merge Y 0 0"
	 << "\n[end signals]"
	 << "\n[end]" << endl;

	return 0;
	
} //Fim da funo main()

